// conndoc.cpp : implementation of the CConnectDoc class
//

#include "stdafx.h"
#include "wsempire.h"

#include "conndoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectDoc

IMPLEMENT_DYNCREATE(CConnectDoc, CDocument)

BEGIN_MESSAGE_MAP(CConnectDoc, CDocument)
	//{{AFX_MSG_MAP(CConnectDoc)
	ON_UPDATE_COMMAND_UI(IDM_EXECUTE, OnUpdateExecute)
	ON_UPDATE_COMMAND_UI(IDM_HISTORY, OnUpdateHistory)
	ON_UPDATE_COMMAND_UI(IDM_MAP_VIEW, OnUpdateMapView)
	ON_UPDATE_COMMAND_UI(IDM_REPEAT, OnUpdateRepeat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectDoc construction/destruction

CConnectDoc::CConnectDoc()
{
mdoc_stringHost = "";
mdoc_stringPort = "";
mdoc_stringUser = "";
mdoc_stringCoun = "";
mdoc_stringPass = "";
mdoc_stringAuxFilename = "wsempire.aux";
mdoc_nPointSize = AfxGetApp()->GetProfileInt("Printer", "FontSize", 8);
mdoc_nLBWidth = AfxGetApp()->GetProfileInt("ListBox", "Width", 345); 
mdoc_nLBHeight = AfxGetApp()->GetProfileInt("ListBox", "Height", 162);
mdoc_nLBFontHeight = -1 * AfxGetApp()->GetProfileInt("Listbox", "FontHeight", 0);
mdoc_nScrollBufferLines = AfxGetApp()->GetProfileInt("Listbox","ScrollBufferLines",100);
mdoc_stringWavDefault = AfxGetApp()->GetProfileString("Sounds", "Default", "default.wav");
mdoc_stringWavLogon = AfxGetApp()->GetProfileString("Sounds", "Logon", "default.wav");
mdoc_stringWavLogoff = AfxGetApp()->GetProfileString("Sounds", "Logoff", "default.wav");
mdoc_stringWavOnFlashMsg = AfxGetApp()->GetProfileString("Sounds", "OnFlashMsg", "default.wav");
mdoc_stringWavOnInformMsg = AfxGetApp()->GetProfileString("Sounds", "OnInformMsg", "default.wav");
mdoc_stringExecFilename = "";
mdoc_bBeep = TRUE;
mdoc_bOnline = FALSE;
mdoc_bSpecialRedraw = FALSE; 
mdoc_bRightBClose = FALSE;
mdoc_Macro1 = AfxGetApp()->GetProfileString("FKeys", "F1", "");
mdoc_Macro2 = AfxGetApp()->GetProfileString("FKeys", "F2", "");
mdoc_Macro3 = AfxGetApp()->GetProfileString("FKeys", "F3", "");
mdoc_Macro4 = AfxGetApp()->GetProfileString("FKeys", "F4", "");
mdoc_Macro5 = AfxGetApp()->GetProfileString("FKeys", "F5", "");
mdoc_Macro6 = AfxGetApp()->GetProfileString("FKeys", "F6", "");
mdoc_Macro7 = AfxGetApp()->GetProfileString("FKeys", "F7", "");
mdoc_Macro8 = AfxGetApp()->GetProfileString("FKeys", "F8", "");
mdoc_Macro9 = AfxGetApp()->GetProfileString("FKeys", "F9", "");
mdoc_Macro10 = AfxGetApp()->GetProfileString("FKeys", "F10", "");

//coord i, x, y, z;
//Cmap *m;

mdoc_MAXX = 0;	// init to 0, dont show a map until set non-zero
mdoc_MAXY = 0;
mdoc_ADJX = 0;
mdoc_ADJY = 0;

mdoc_S1 = MAP_S1;
mdoc_S2 = MAP_S2;
mdoc_S3 = MAP_S3;
mdoc_S4 = MAP_S4;

mdoc_nZoom = 1;
mdoc_nS1 = mdoc_S1 * mdoc_nZoom;
mdoc_nS2 = mdoc_S2 * mdoc_nZoom;
mdoc_nS3 = mdoc_S3 * mdoc_nZoom;
mdoc_nS4 = mdoc_S4 * mdoc_nZoom; 

mdoc_bShowHighlight = TRUE;
mdoc_bShowMapChar = TRUE;
mdoc_bShowDist = FALSE;
mdoc_bShowShips = TRUE;
mdoc_bShowPlanes = TRUE;
mdoc_bShowLand = TRUE;
mdoc_bShowNukes = TRUE;
mdoc_bShowMil = TRUE;
mdoc_bPrintHexGrid = TRUE;

#ifdef SHIT
for(x=0;x<mdoc_MAXX;x++)
	for(y=0;y<mdoc_MAXY;y++)
		{
		z = x + y;
		i = ((y*mdoc_MAXX)+x);
		if( z % 2 )
			{
			db[i] = (Cmap *)(-1);
			continue;
			}
		db[i] = new Cmap; // in if def , dont worry
		if( db[i] == (Cmap *)0 )
			AfxMessageBox("new failed in constructor");
		m = db[i];
		m->coUserX = x - mdoc_ADJX;
		m->coUserY = y - mdoc_ADJY;
		m->coSysX = x;
		m->coSysY = y;
		m->coDistX = m->coUserX;
		m->coDistY = m->coUserY;
		
		m->ucObjFlags = 0;
		m->ucHighlighted = FALSE;		
		m->ucOwned = MAP_OWNED_UNKNOWN;		
		m->ucMapChar = ' ';

        m->ucNewDes = '_';
		m->ucEff = 0;
		m->ucMob = 0;
        m->ucOccupied = 0;
        
        m->ucProdOff = 0;
        m->ucMinContent = 0;
		m->ucGoldContent = 0;
		m->ucFert = 0;
		
		m->ucOilContent = 0;
		m->ucUranContent = 0;
		m->ucWork = 0;
		m->ucTerr = 0;
		
		m->hnAvail = 0;
		m->unCiv = 0;
		m->unMil = 0;
		m->unUW = 0;
		m->unFood = 0;
		m->unShells = 0;
		m->unGuns = 0;		
		m->unPetrol = 0;		
		m->unIron = 0;		
		m->unDust = 0;		
		m->unBars = 0;		
		m->unOil = 0;		
		m->unLcm = 0;		
		m->unHcm = 0;
		m->unRads = 0;
		
		m->unCdist = 0;
		m->unMdist = 0;
		m->unUdist = 0;
		m->unFdist = 0;
		m->unSdist = 0;
		m->unGdist = 0;
		m->unPdist = 0;
		m->unIdist = 0;
		m->unDdist = 0;
		m->unBdist = 0;
		m->unOdist = 0;
		m->unLdist = 0;
		m->unHdist = 0;
		m->unRdist = 0;

		m->rect = CRect(0,0,0,0);
		m->ucRedraw = TRUE;
		m->ucUU2 = FALSE;
		}
#endif /* shit */
}



CConnectDoc::~CConnectDoc()
{
coord i, x, y;
for(x=0;x<mdoc_MAXX;x++)
	for(y=0;y<mdoc_MAXY;y++)  
		{
		i = ((y*mdoc_MAXX)+x);		
		if( (db[i] != (Cmap *)0) && (db[i] != (Cmap *)(-1)) )
			delete db[i];
		}
}



BOOL CConnectDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CConnectDoc serialization

void CConnectDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		ar << mdoc_stringHost << mdoc_stringPort << mdoc_stringUser << mdoc_stringCoun << mdoc_stringPass;
	}
	else
	{
		// TODO: add loading code here
		ar >> mdoc_stringHost >> mdoc_stringPort >> mdoc_stringUser >> mdoc_stringCoun >> mdoc_stringPass;		
	}
}

/////////////////////////////////////////////////////////////////////////////
// CConnectDoc diagnostics

#ifdef _DEBUG
void CConnectDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CConnectDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////
// CConnectDoc commands

Cmap *CConnectDoc::GetUserSect(coord x, coord y)
{
coord i;

x = x + mdoc_ADJX;
y = y + mdoc_ADJY;
i = x + (y * mdoc_MAXX);

// below for debug only
if( (x+y) % 2 )
	{
	AfxMessageBox("odd in GetUserSect");
	return( (Cmap *)0 );
	}	

return( db[i] );
}
 
 

Cmap *CConnectDoc::GetSysSect(coord x, coord y)
{
coord i;

i = x + (y * mdoc_MAXX);                   

// below for debug only
if( (x+y) % 2 )
	{
	AfxMessageBox("odd in GetSysSect");
	return( (Cmap *)0 );
	}

return( db[i] );
}




void CConnectDoc::SetUserSectMapChar(coord x, coord y, u_char ucMapChar)
{
coord i;

x = x + mdoc_ADJX;
y = y + mdoc_ADJY;
i = x + (y * mdoc_MAXX);
// below for debug only
if( (x+y) % 2 )
	AfxMessageBox("odd in SetUserSectMapChar");
	
(db[i])->ucMapChar = ucMapChar;
}




void CConnectDoc::SetUserSectOwned(coord x, coord y, u_char ucOwned)
{
coord i;

x = x + mdoc_ADJX;
y = y + mdoc_ADJY;
i = x + (y * mdoc_MAXX);
// below for debug only
if( (x+y) % 2 )
	AfxMessageBox("odd in SetUserSectOwned");
	
(db[i])->ucOwned = ucOwned;
}


void CConnectDoc::SetUserSectHighlighted(coord x, coord y, u_char ucHighlighted)
{
coord i;

x = x + mdoc_ADJX;
y = y + mdoc_ADJY;
i = x + (y * mdoc_MAXX);
// below for debug only
if( (x+y) % 2 )
	AfxMessageBox("odd in SetUserSectHighlighted");
	
(db[i])->ucHighlighted = ucHighlighted;
(db[i])->ucRedraw = TRUE;
} // end of SetUserSectHighlighted




void CConnectDoc::OnUpdateExecute(CCmdUI* pCmdUI)
{
pCmdUI->Enable(mdoc_bOnline);
	
}

void CConnectDoc::OnUpdateHistory(CCmdUI* pCmdUI)
{
pCmdUI->Enable(mdoc_bOnline);	
}

void CConnectDoc::OnUpdateMapView(CCmdUI* pCmdUI)
{
pCmdUI->Enable(mdoc_bOnline);
}

void CConnectDoc::OnUpdateRepeat(CCmdUI* pCmdUI)
{
pCmdUI->Enable(mdoc_bOnline);	
}

