// connvw2.cpp : implementation of the CConnectView class
//

#include "stdafx.h" 
#include "mmsystem.h"
#include "wsempire.h"

#include "conndoc.h"
#include "connvw.h"
#include "hostdlg.h"
#include "fexecdlg.h"
#include "historyd.h"

#include "servpge.h"
#include "sounpge.h"
#include "genpge.h"
#include "macrpge.h"

#include <ctype.h>
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectView 2


void CConnectView::OnDebug()
{
CConnectDoc* pDoc = GetDocument();
CEmpShip *pship;
CEmpPlane *pplane;
CEmpLand *pland;
CString s;
char str[120];

POSITION posS = pDoc->mdoc_ShipList.GetHeadPosition();
while( posS != NULL )
	{
	pship = (CEmpShip *)pDoc->mdoc_ShipList.GetNext( posS );
	wsprintf(str,"%4d %-16.16s %4d,%-4d %1c%4d%%%4d%4d%4d%4d%3d%3d%3d%3d%4d%5d%4d %s",
		(int)pship->unNum,
		(const char *)pship->sType,
		(int)pship->coUserX,
		(int)pship->coUserY,
		pship->ucMembership,
		(int)pship->ucEff,
		(int)pship->unCiv,
		(int)pship->unMil,
		(int)pship->unUW,
		(int)pship->unFood,
		(int)pship->ucPlanes,
		(int)pship->ucHelis,
		(int)pship->ucXlights,
		(int)pship->ucLands,
		(int)pship->ucMob,
		(int)pship->unFuel,
		(int)pship->unTech,
		(const char *)pship->sShipname);
	s = str;
	AddToListBox(s,ATLB_SETCURSEL);
	}                                       

POSITION posL = pDoc->mdoc_LandList.GetHeadPosition();	
while( posL != NULL )
	{
	pland = (CEmpLand *)pDoc->mdoc_LandList.GetNext( posL );
	wsprintf(str,"%4d %-16.16s   %4d,%-4d %1c%4d%%%5d%4d%5d%5d%5d %3d%%%4d%3d%5d",
		(int)pland->unNum,
		(const char *)pland->sType,
		(int)pland->coUserX,
		(int)pland->coUserY,
		pland->ucMembership,
		(int)pland->ucEff,
		(int)pland->ucFort,
		(int)pland->ucMob,
        (int)pland->unFood,
		(int)pland->unFuel,
		(int)pland->unTech,
		(int)pland->ucRetreat,
		(int)pland->ucRadius,
		(int)pland->ucXlights,
		(int)pland->unCarryShip);
	s = str;
	AddToListBox(s,ATLB_SETCURSEL);
	}

POSITION posP = pDoc->mdoc_PlaneList.GetHeadPosition();	
while( posP != NULL )
	{
	pplane = (CEmpPlane *)pDoc->mdoc_PlaneList.GetNext( posP );
	wsprintf(str,"%4d %-19.19s %4d,%-4d %c %3d%% %3d %3d %3d  %3d %3d  %3d%5d%c %c %c %d %s",
		(int)pplane->unNum,
		(const char *)pplane->sType,
		(int)pplane->coUserX,
		(int)pplane->coUserY,
		pplane->ucMembership,
		(int)pplane->ucEff,
		(int)pplane->ucMob,
        (int)pplane->ucAtt,
		(int)pplane->ucDef,
		(int)pplane->unTech,
		(int)pplane->ucRange,
		(int)pplane->ucHard,
		(int)pplane->unCarryUnit,
		pplane->ucCarryType,
		pplane->ucLaunched,
		pplane->ucSync,
		(int)pplane->ucNukeAmt,
		pplane->sNukeType);
	s = str;
	AddToListBox(s,ATLB_SETCURSEL);
	}

} // end of OnDebug




void CConnectView::OnMacro1()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro1.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro1);
SendMacro(lpszCommand);
} // CConnectView::OnMacro1


void CConnectView::OnMacro2()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro2.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro2);
SendMacro(lpszCommand);
} // CConnectView::OnMacro2


void CConnectView::OnMacro3()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro3.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro3);
SendMacro(lpszCommand);
} // CConnectView::OnMacro3


void CConnectView::OnMacro4()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro4.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro4);
SendMacro(lpszCommand);
} // CConnectView::OnMacro4


void CConnectView::OnMacro5()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro5.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro5);
SendMacro(lpszCommand);
} // CConnectView::OnMacro5


void CConnectView::OnMacro6()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro6.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro6);
SendMacro(lpszCommand);
} // CConnectView::OnMacro6


void CConnectView::OnMacro7()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro7.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro7);
SendMacro(lpszCommand);
} // CConnectView::OnMacro7


void CConnectView::OnMacro8()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro8.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro8);
SendMacro(lpszCommand);
} // CConnectView::OnMacro8


void CConnectView::OnMacro9()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro9.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro9);
SendMacro(lpszCommand);
} // CConnectView::OnMacro9


void CConnectView::OnMacro10()
{
CConnectDoc* pDoc = GetDocument();
char lpszCommand[128];
if( pDoc->mdoc_Macro10.GetLength() <= 0 )
	return;
lstrcpy(lpszCommand,(const char *)pDoc->mdoc_Macro10);
SendMacro(lpszCommand);
} // CConnectView::OnMacro10




void CConnectView::SendMacro(char *lpszCommand)
{
char lpszToLB[128];                                        
lstrcpy(m_SendBuf, lpszCommand);	// store in SendBuf
m_stringPrevCmd = lpszCommand;
m_nLastHistory++;
if( m_nLastHistory >= EMP_HISTORY_STRINGS )
	m_nLastHistory = 0;
m_stringHistory[m_nLastHistory] = m_stringPrevCmd;
    
lstrcpy(lpszToLB,"> ");				// "prompt" for cmd text in ListBox
lstrcat(lpszToLB, lpszCommand);		// actual command follows my "prompt"
AddToListBox(lpszToLB,ATLB_SETCURSEL);	// store in ListBox
if( m_bAuxFile )	
	AddToAuxFile(lpszToLB);
	
lpszCommand[0] = '\0';                                      // zero cmd string for use
SetDlgItemText(IDC_CONNVIEW_CMD, lpszCommand);              // in resetting cmd edit control
	// Set focus to the Command: edit box
((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_CONNVIEW_CMD));

lstrcat(m_SendBuf, "\n");                                   // add a newline to be sent to emp server
m_nBytesToSend = m_nTotalBytesToSend = lstrlen(m_SendBuf);	
PostMessage(WM_USER_ASYNC_SELECT, m_s, WSAMAKESELECTREPLY(FD_WRITE, 0));	
} // end of CConnectView::SendMacro



void CConnectView::OnPreferences()
{
CConnectDoc* pDoc = GetDocument();
ASSERT_VALID(pDoc);
char str[80];               

// Declare the overall sheet plus its pages
CPropertySheet dlgPropertySheet("WS Empire Preferences");
CServPage servPage;
CGeneralPage genPage;
CSoundPage sounPage;
CMacroPage macrPage;

// Set servPage data
wsprintf(str,"%d",pDoc->mdoc_MAXX);	servPage.m_MAXX = str;
wsprintf(str,"%d",pDoc->mdoc_MAXY);	servPage.m_MAXY = str;
servPage.m_Host = pDoc->mdoc_stringHost;
servPage.m_Port = pDoc->mdoc_stringPort;
servPage.m_User = pDoc->mdoc_stringUser;
servPage.m_Coun = pDoc->mdoc_stringCoun;
servPage.m_Pass = pDoc->mdoc_stringPass;

// Set genPage data
wsprintf(str,"%d",pDoc->mdoc_nLBHeight); genPage.m_Height = str;
wsprintf(str,"%d",pDoc->mdoc_nLBWidth);	genPage.m_Width = str;
wsprintf(str,"%d", -1 * pDoc->mdoc_nLBFontHeight); genPage.m_LBFontSize = str;
wsprintf(str,"%d",(int)pDoc->mdoc_nScrollBufferLines); genPage.m_Maxlines = str;
wsprintf(str,"%d",pDoc->mdoc_nPointSize); genPage.m_PRTFontSize = str;
genPage.m_Capture = pDoc->mdoc_stringAuxFilename;

// Set sounPage data
sounPage.m_UseSounds = pDoc->mdoc_bBeep;
sounPage.m_Default = pDoc->mdoc_stringWavDefault;
sounPage.m_Logon = pDoc->mdoc_stringWavLogon;
sounPage.m_Logoff = pDoc->mdoc_stringWavLogoff;
sounPage.m_OnFlashMsg = pDoc->mdoc_stringWavOnFlashMsg;
sounPage.m_OnInformMsg = pDoc->mdoc_stringWavOnInformMsg;

// Set macrPage data
macrPage.m_F1 = pDoc->mdoc_Macro1;
macrPage.m_F2 = pDoc->mdoc_Macro2;
macrPage.m_F3 = pDoc->mdoc_Macro3;
macrPage.m_F4 = pDoc->mdoc_Macro4;
macrPage.m_F5 = pDoc->mdoc_Macro5;
macrPage.m_F6 = pDoc->mdoc_Macro6;
macrPage.m_F7 = pDoc->mdoc_Macro7;
macrPage.m_F8 = pDoc->mdoc_Macro8;
macrPage.m_F9 = pDoc->mdoc_Macro9;
macrPage.m_F10 = pDoc->mdoc_Macro10;

// Add pages into sheet
dlgPropertySheet.AddPage(&servPage);
dlgPropertySheet.AddPage(&genPage);
dlgPropertySheet.AddPage(&sounPage);
dlgPropertySheet.AddPage(&macrPage);

// Run this as a Modal dialog
if( dlgPropertySheet.DoModal() == IDOK )
	{
	// Get data on servPage:
	if( pDoc->mdoc_stringHost != servPage.m_Host )
		{
		pDoc->mdoc_stringHost = servPage.m_Host;
		pDoc->SetModifiedFlag(TRUE);
		} 
	if( pDoc->mdoc_stringPort != servPage.m_Port )
		{
		pDoc->mdoc_stringPort = servPage.m_Port;
		pDoc->SetModifiedFlag(TRUE);	
		}
	if( pDoc->mdoc_stringUser != servPage.m_User )
		{
		pDoc->mdoc_stringUser = servPage.m_User;
		pDoc->SetModifiedFlag(TRUE);	
		}
	if( pDoc->mdoc_stringCoun != servPage.m_Coun )
		{
		pDoc->mdoc_stringCoun = servPage.m_Coun;
		pDoc->SetModifiedFlag(TRUE);	
		}
	if( pDoc->mdoc_stringPass != servPage.m_Pass )
		{
		pDoc->mdoc_stringPass = servPage.m_Pass;
		pDoc->SetModifiedFlag(TRUE);
		}
	if( pDoc->mdoc_MAXX != atoi(servPage.m_MAXX) )
		{
		pDoc->mdoc_MAXX = atoi(servPage.m_MAXX);
		pDoc->mdoc_ADJX = pDoc->mdoc_MAXX / 2;
		pDoc->SetModifiedFlag(TRUE);
		}
	if( pDoc->mdoc_MAXY != atoi(servPage.m_MAXY) )
		{
		pDoc->mdoc_MAXY = atoi(servPage.m_MAXY);
		pDoc->mdoc_ADJY = pDoc->mdoc_MAXY / 2;
		pDoc->SetModifiedFlag(TRUE);
		}			

	// Get data on genPage
	if( pDoc->mdoc_nLBHeight != atoi(genPage.m_Height) )
		{
		pDoc->mdoc_nLBHeight = atoi(genPage.m_Height);
		AfxGetApp()->WriteProfileInt("ListBox", "Height", pDoc->mdoc_nLBHeight);
		}
	if( pDoc->mdoc_nLBWidth != atoi(genPage.m_Width) )
		{
		pDoc->mdoc_nLBWidth = atoi(genPage.m_Width);
		AfxGetApp()->WriteProfileInt("ListBox", "Width", pDoc->mdoc_nLBWidth);
		}
	if( pDoc->mdoc_nLBFontHeight !=  (-1 * atoi(genPage.m_LBFontSize)) )
		{
		pDoc->mdoc_nLBFontHeight =  -1 * atoi(genPage.m_LBFontSize);
		AfxGetApp()->WriteProfileInt("Listbox", "FontHeight", pDoc->mdoc_nLBFontHeight);
		}
	if( pDoc->mdoc_nScrollBufferLines != (UINT)atoi(genPage.m_Maxlines) )
		{
		pDoc->mdoc_nScrollBufferLines = (UINT)atoi(genPage.m_Maxlines);
		AfxGetApp()->WriteProfileInt("Listbox","ScrollBufferLines",pDoc->mdoc_nScrollBufferLines);
		}
	if( pDoc->mdoc_nPointSize != atoi(genPage.m_PRTFontSize) )
		{
		pDoc->mdoc_nPointSize = atoi(genPage.m_PRTFontSize);
		AfxGetApp()->WriteProfileInt("Printer", "FontSize", pDoc->mdoc_nPointSize);
		}
	if( pDoc->mdoc_stringAuxFilename != genPage.m_Capture )
		{
		pDoc->mdoc_stringAuxFilename = genPage.m_Capture;
		AfxGetApp()->WriteProfileString("Listbox", "AuxFile", pDoc->mdoc_stringAuxFilename);	
		}
	CListBox *plb = (CListBox *)GetDlgItem(IDC_CONNVIEW_LISTBOX);
	CRect rlb, rp;
	GetWindowRect( &rp );
	plb->GetWindowRect( &rlb );
	plb->MoveWindow((rlb.left - rp.left - 1), (rlb.top - rp.top - 1), pDoc->mdoc_nLBWidth, pDoc->mdoc_nLBHeight, TRUE);

	// Get data on sounPage
	pDoc->mdoc_bBeep = sounPage.m_UseSounds;
	if( pDoc->mdoc_stringWavDefault != sounPage.m_Default )
		{
		pDoc->mdoc_stringWavDefault = sounPage.m_Default;
		AfxGetApp()->WriteProfileString("Sounds", "Default", sounPage.m_Default);
		}
	if( pDoc->mdoc_stringWavLogon != sounPage.m_Logon )
		{
		pDoc->mdoc_stringWavLogon = sounPage.m_Logon;
		AfxGetApp()->WriteProfileString("Sounds", "Logon", sounPage.m_Logon);
		}
	if( pDoc->mdoc_stringWavLogoff != sounPage.m_Logoff )
		{
		pDoc->mdoc_stringWavLogoff = sounPage.m_Logoff;
		AfxGetApp()->WriteProfileString("Sounds", "Logoff", sounPage.m_Logoff);
		}
	if( pDoc->mdoc_stringWavOnFlashMsg != sounPage.m_OnFlashMsg )
		{
		pDoc->mdoc_stringWavOnFlashMsg = sounPage.m_OnFlashMsg;
		AfxGetApp()->WriteProfileString("Sounds", "OnFlashMsg", sounPage.m_OnFlashMsg);
		}
	if( pDoc->mdoc_stringWavOnInformMsg != sounPage.m_OnInformMsg )
		{
		pDoc->mdoc_stringWavOnInformMsg = sounPage.m_OnInformMsg;
		AfxGetApp()->WriteProfileString("Sounds", "OnInformMsg", sounPage.m_OnInformMsg);
		}
	// Get data on macrPage
	if( pDoc->mdoc_Macro1 != macrPage.m_F1 )
		{
		pDoc->mdoc_Macro1 = macrPage.m_F1;
		AfxGetApp()->WriteProfileString("FKeys", "F1", macrPage.m_F1);
		}
	if( pDoc->mdoc_Macro2 != macrPage.m_F2 )
		{
		pDoc->mdoc_Macro2 = macrPage.m_F2;
		AfxGetApp()->WriteProfileString("FKeys", "F2", macrPage.m_F2);
		}
	if( pDoc->mdoc_Macro3 != macrPage.m_F3 )
		{
		pDoc->mdoc_Macro3 = macrPage.m_F3;
		AfxGetApp()->WriteProfileString("FKeys", "F3", macrPage.m_F3);
		}
	if( pDoc->mdoc_Macro4 != macrPage.m_F4 )
		{
		pDoc->mdoc_Macro4 = macrPage.m_F4;
		AfxGetApp()->WriteProfileString("FKeys", "F4", macrPage.m_F4);
		}
	if( pDoc->mdoc_Macro5 != macrPage.m_F5 )
		{
		pDoc->mdoc_Macro5 = macrPage.m_F5;
		AfxGetApp()->WriteProfileString("FKeys", "F5", macrPage.m_F5);
		}
	if( pDoc->mdoc_Macro6 != macrPage.m_F6 )
		{
		pDoc->mdoc_Macro6 = macrPage.m_F6;
		AfxGetApp()->WriteProfileString("FKeys", "F6", macrPage.m_F6);
		}
	if( pDoc->mdoc_Macro7 != macrPage.m_F7 )
		{
		pDoc->mdoc_Macro7 = macrPage.m_F7;
		AfxGetApp()->WriteProfileString("FKeys", "F7", macrPage.m_F7);
		}
	if( pDoc->mdoc_Macro8 != macrPage.m_F8 )
		{
		pDoc->mdoc_Macro8 = macrPage.m_F8;
		AfxGetApp()->WriteProfileString("FKeys", "F8", macrPage.m_F8);
		}
	if( pDoc->mdoc_Macro9 != macrPage.m_F9 )
		{
		pDoc->mdoc_Macro9 = macrPage.m_F9;
		AfxGetApp()->WriteProfileString("FKeys", "F9", macrPage.m_F9);
		}
	if( pDoc->mdoc_Macro10 != macrPage.m_F10 )
		{
		pDoc->mdoc_Macro10 = macrPage.m_F10;
		AfxGetApp()->WriteProfileString("FKeys", "F10", macrPage.m_F10);
		}
	//pDoc->UpdateAllViews(NULL);
	}
	
} // end of OnPreferences



