// printopt.cpp : implementation file
//

#include "stdafx.h"
#include "wsempire.h"
#include "printopt.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPrintOptions dialog


CPrintOptions::CPrintOptions(CWnd* pParent /*=NULL*/)
	: CDialog(CPrintOptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPrintOptions)
	m_nPrinterPointSize = 10;
	//}}AFX_DATA_INIT
}

void CPrintOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrintOptions)
	DDX_Text(pDX, IDC_PRINTER_POINTSIZE, m_nPrinterPointSize);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPrintOptions, CDialog)
	//{{AFX_MSG_MAP(CPrintOptions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPrintOptions message handlers

void CPrintOptions::OnOK()
{
	UpdateData(TRUE);
	EndDialog(IDOK);	
}

BOOL CPrintOptions::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	UpdateData(FALSE);
							// Set focus to the pointsize EDIT control.
	((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_PRINTER_POINTSIZE));	
	return FALSE;  // return TRUE  unless you set the focus to a control
}
