// sectinfo.cpp : implementation file
//

#include "stdafx.h"
#include "wsempire.h"
#include "sectinfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSectInfo dialog


CSectInfo::CSectInfo(CView* pView)
	: CDialog()
{
	//{{AFX_DATA_INIT(CSectInfo)
	m_des = "";
	m_civ = "";
	m_eff = "";
	m_food = "";
	m_mil = "";
	m_mob = "";
	m_uw = "";
	m_dist_xy = "";
	m_bars = "";
	m_dust = "";
	m_guns = "";
	m_hcm = "";
	m_iron = "";
	m_lcm = "";
	m_oil = "";
	m_petrol = "";
	m_rads = "";
	m_shells = "";
	//}}AFX_DATA_INIT
	m_pView = pView;
}

void CSectInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSectInfo)
	DDX_Text(pDX, IDC_SECT_DES, m_des);
	DDX_Text(pDX, IDC_SECT_CIV, m_civ);
	DDX_Text(pDX, IDC_SECT_EFF, m_eff);
	DDX_Text(pDX, IDC_SECT_FOOD, m_food);
	DDX_Text(pDX, IDC_SECT_MIL, m_mil);
	DDX_Text(pDX, IDC_SECT_MOB, m_mob);
	DDX_Text(pDX, IDC_SECT_UW, m_uw);
	DDX_Text(pDX, IDC_DIST_XY, m_dist_xy);
	DDX_Text(pDX, IDC_SECT_BARS, m_bars);
	DDX_Text(pDX, IDC_SECT_DUST, m_dust);
	DDX_Text(pDX, IDC_SECT_GUNS, m_guns);
	DDX_Text(pDX, IDC_SECT_HCM, m_hcm);
	DDX_Text(pDX, IDC_SECT_IRON, m_iron);
	DDX_Text(pDX, IDC_SECT_LCM, m_lcm);
	DDX_Text(pDX, IDC_SECT_OIL, m_oil);
	DDX_Text(pDX, IDC_SECT_PETROL, m_petrol);
	DDX_Text(pDX, IDC_SECT_RADS, m_rads);
	DDX_Text(pDX, IDC_SECT_SHELLS, m_shells);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSectInfo, CDialog)
	//{{AFX_MSG_MAP(CSectInfo)
	ON_BN_CLICKED(IDC_SECT_MIL_BUTTON, OnSectMilButton)
	ON_BN_CLICKED(IDC_SECT_DIST_BUTTON, OnSectDistButton)
	ON_BN_CLICKED(IDC_SECT_LAND_BUTTON, OnSectLandButton)
	ON_BN_CLICKED(IDC_SECT_NUKES_BUTTON, OnSectNukesButton)
	ON_BN_CLICKED(IDC_SECT_PLANES_BUTTON, OnSectPlanesButton)
	ON_BN_CLICKED(IDC_SECT_SHIPS_BUTTON, OnSectShipsButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSectInfo message handlers

BOOL CSectInfo::Create()
{
return CDialog::Create(CSectInfo::IDD);
}


void CSectInfo::OnCancel()
{
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_INFO, IDCANCEL); }
}



void CSectInfo::OnOK()
{
	UpdateData(TRUE);
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_INFO, IDOK); }	
}




BOOL CSectInfo::OnInitDialog()
{
	VERIFY(m_Mil.AutoLoad(IDC_SECT_MIL_BUTTON, this));
	VERIFY(m_Dist.AutoLoad(IDC_SECT_DIST_BUTTON, this));	
	VERIFY(m_Ship.AutoLoad(IDC_SECT_SHIPS_BUTTON, this));	
	VERIFY(m_Plane.AutoLoad(IDC_SECT_PLANES_BUTTON, this));	
	VERIFY(m_Land.AutoLoad(IDC_SECT_LAND_BUTTON, this));	
	VERIFY(m_Nuke.AutoLoad(IDC_SECT_NUKES_BUTTON, this));	
	
//	return CDialog::OnInitDialog();
	
	CDialog::OnInitDialog();
	
	UpdateData(FALSE);
		
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CSectInfo::OnSectMilButton()
{
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_BUTTON, SECT_BUTTON_MIL); }	
}
 
 
 
void CSectInfo::OnSectDistButton()
{
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_BUTTON, SECT_BUTTON_DIST); }	
}



void CSectInfo::OnSectLandButton()
{
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_BUTTON, SECT_BUTTON_LAND); }	
}



void CSectInfo::OnSectNukesButton()
{
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_BUTTON, SECT_BUTTON_NUKES); }	
}



void CSectInfo::OnSectPlanesButton()
{
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_BUTTON, SECT_BUTTON_PLANES); }	
}



void CSectInfo::OnSectShipsButton()
{
	if( m_pView != NULL )
		{ m_pView->PostMessage(WM_USER_SECT_BUTTON, SECT_BUTTON_SHIPS); }	
}
