// sectinfo.h : header file
//

#define SECT_BUTTON_MIL		1
#define SECT_BUTTON_DIST	2
#define SECT_BUTTON_LAND	3
#define SECT_BUTTON_NUKES	4
#define SECT_BUTTON_PLANES	5
#define SECT_BUTTON_SHIPS	6


/////////////////////////////////////////////////////////////////////////////
// CSectInfo dialog

class CSectInfo : public CDialog
{
// Construction
public:
	CSectInfo(CView* pView);
	BOOL Create();

public:	
    CView *m_pView;
    CBitmapButton m_Mil;
    CBitmapButton m_Dist;
    CBitmapButton m_Ship;
    CBitmapButton m_Plane;
    CBitmapButton m_Land;
    CBitmapButton m_Nuke;
    
// Dialog Data
	//{{AFX_DATA(CSectInfo)
	enum { IDD = IDD_SECT_INFO };
	CString	m_des;
	CString	m_civ;
	CString	m_eff;
	CString	m_food;
	CString	m_mil;
	CString	m_mob;
	CString	m_uw;
	CString	m_dist_xy;
	CString	m_bars;
	CString	m_dust;
	CString	m_guns;
	CString	m_hcm;
	CString	m_iron;
	CString	m_lcm;
	CString	m_oil;
	CString	m_petrol;
	CString	m_rads;
	CString	m_shells;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	// Generated message map functions
	//{{AFX_MSG(CSectInfo)
	virtual void OnCancel();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnSectMilButton();
	afx_msg void OnSectDistButton();
	afx_msg void OnSectLandButton();
	afx_msg void OnSectNukesButton();
	afx_msg void OnSectPlanesButton();
	afx_msg void OnSectShipsButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
