// hostdlg.cpp : implementation file
//

#include "stdafx.h"
#include "wsempire.h"
#include "hostdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHostDlg dialog


CHostDlg::CHostDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHostDlg::IDD, pParent)
{
// host, port, etc are filled in by view before this
// dlg is run via DoModal().

	//{{AFX_DATA_INIT(CHostDlg)
	m_stringCoun = "";
	m_stringHost = "";
	m_stringPass = "";
	m_stringPort = "";
	m_stringUser = "";		
	m_bKillProc = FALSE;
	m_stringMAXX = "";
	m_stringMAXY = "";
	//}}AFX_DATA_INIT
}

void CHostDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHostDlg)
	DDX_Text(pDX, IDC_SERVER_COUN, m_stringCoun);
	DDX_Text(pDX, IDC_SERVER_HOST, m_stringHost);
	DDX_Text(pDX, IDC_SERVER_PASS, m_stringPass);
	DDX_Text(pDX, IDC_SERVER_PORT, m_stringPort);
	DDX_Text(pDX, IDC_SERVER_USER, m_stringUser);
	DDX_Check(pDX, IDC_SERVER_KILLPROC, m_bKillProc);
	DDX_Text(pDX, IDC_SERVER_MAXX, m_stringMAXX);
	DDX_Text(pDX, IDC_SERVER_MAXY, m_stringMAXY);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHostDlg, CDialog)
	//{{AFX_MSG_MAP(CHostDlg)
	ON_BN_CLICKED(IDOK, OnHostDlgOKbutton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CHostDlg message handlers

void CHostDlg::OnHostDlgOKbutton()
{

	// pressed the OK button when entering host info
	UpdateData(TRUE);	// get data from Dlg into member strings.
	EndDialog(IDOK);	// this dialog is done, send IDOK as the reason.
}



BOOL CHostDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	UpdateData(FALSE);		// send member strings to _EDIT_ controls.
	 
							// Set focus to the Host name EDIT control.
	((CDialog*)this)->GotoDlgCtrl(GetDlgItem(IDC_SERVER_HOST));
	
	return FALSE;  // return TRUE  unless you set the focus to a control
}
